from gint import *
import game_sys
import game_map
import sys


game = game_sys.Game(game_map.map, game_map.graph,[78,80,34,81,95,85,93,82,96])
e1_crystal = game_sys.Crystal()
e1_crystal.position = [596, 312]
game.entities.append(e1_crystal)

e2_crystal = game_sys.Crystal()
e2_crystal.position = [52, 52]
game.entities.append(e2_crystal)

e3_crystal = game_sys.Crystal()
e3_crystal.position = [1140, 500]
game.entities.append(e3_crystal)

game.player.position = [580,350]
game.MoveCamera(25*16,14*16)

for i in range(8):
    game.SpawnSkeleton()
    for j in range(20):
        game.Update()
#main Menu
def main_menu():
    game.map.DrawAll()
    game_sys.DrawMainLogo(119,30)
    game_sys.DrawPanel((119, 110),(280, 190))
    color = [C_BLACK, C_BLACK]
    idx = 0
    while True:
        cleareventflips()
        clearevents()
        if keypressed(KEY_UP):
            idx = (idx - 1) % 2
        elif keypressed(KEY_DOWN):
            idx = (idx + 1) % 2
        for i in range(2):
            color[i] = C_WHITE if i == idx else C_BLACK
        dtext_opt(199, 135, color[0], 43463, DTEXT_CENTER,DTEXT_MIDDLE, "New Game", 16)
        dtext_opt(199, 165, color[1], 43463, DTEXT_CENTER,DTEXT_MIDDLE, "Exit", 16)
        dupdate()
        if keypressed(KEY_EXE) or keypressed(KEY_SHIFT):
            if idx == 0:
                break
            elif idx == 1:
                sys.exit(0)
    game.Refresh()

def pause_menu():
    xoffset, yoffset = 50, 50
    for y in range(game.map.height):
        for x in range(game.map.width):
            idx = game.map.Get(x, y)
            tx = x * 2 + xoffset
            ty = y * 2 + yoffset
            drect(tx, ty, tx+2, ty+2, C_BLUE if idx in game_sys.Character.COLLIDER_IDS else C_BLACK)
    for entity in game.entities:
        x, y = entity.position
        tx = int(x//game.map.tile_size) * 2 + xoffset
        ty = int(y//game.map.tile_size) * 2 + yoffset
        color = C_WHITE
        if isinstance(entity, game_sys.Crystal):
            color = C_GREEN
        elif isinstance(entity, game_sys.Skeleton):
            color = C_RED
        drect(tx, ty, tx+2, ty+2, color)
    game_sys.DrawPanel((220, 50),(330, 130))
    color = [C_BLACK, C_BLACK]
    idx = 0
    while True:
        cleareventflips()
        clearevents()
        if keypressed(KEY_MENU):
            break
        if keypressed(KEY_UP):
            idx = (idx - 1) % 2
        elif keypressed(KEY_DOWN):
            idx = (idx + 1) % 2
        for i in range(2):
            color[i] = C_WHITE if i == idx else C_BLACK
        dtext_opt(270, 70, color[0], 43463, DTEXT_CENTER,DTEXT_MIDDLE, "Resume", 16)
        dtext_opt(270, 90, color[1], 43463, DTEXT_CENTER,DTEXT_MIDDLE, "Exit", 16)
        dupdate()
        if keypressed(KEY_EXE) or keypressed(KEY_SHIFT):
            if idx == 0:
                break
            elif idx == 1:
                sys.exit(0)
    game.Refresh()

def gameover():
    dclear(C_BLACK)
    game_sys.DrawMainLogo(119,30)
    dtext_opt(DWIDTH//2, 130, C_WHITE, C_BLACK, DTEXT_CENTER,DTEXT_MIDDLE, "Game Over", 32)
    dtext_opt(DWIDTH//2, 170, C_WHITE, C_BLACK, DTEXT_CENTER,DTEXT_MIDDLE, "Exit", 16)
    dupdate()
    while True:
        cleareventflips()
        clearevents()
        if keypressed(KEY_EXE) or keypressed(KEY_SHIFT):
            sys.exit(0)
main_menu()
while not game.quit:
    game.UpdateInput()
    if keypressed(KEY_MENU):
        pause_menu()
    game.Update()
    game.Draw()
    dupdate()
    if game.player.health <= 0 or game.Crystal <= 0:
        gameover()